/*
 * Copyright (C) 2019  Max Regan
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#pragma once

#include "Bsp/macros.h"

#include "Application/ScreenManager.h"
#include "Application/Screens/Screen.h"

class BigDigitalTimeScreen : public Screen {
public:

    BigDigitalTimeScreen(BSP::DisplayDriver &display,
                         ScreenManager &m_manager,
                         Screen &m_menu_screen);

    BSP::ReturnCode init();
    BSP::Schedule::NextTime execute() override;

    void enable() override;
    void disable() override;

    void notify_up_button() override;
    void notify_middle_button() override;
    void notify_down_button() override;

private:

    void display_time();
    void display_number(uint32_t *x, uint32_t y, uint32_t tens, uint32_t ones, const font &f);

    BSP::DisplayDriver &m_driver;
    BSP::WallClockTime m_last_time;

    ScreenManager &m_manager;
    Screen &m_menu_screen;

    const bool m_display_seconds;
};
